// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var GM_gChoices = {
  _type: null,
  _data: null,
  
  load: function()
  {
    var list = GM_getEBI("gm-choices-options");
    var item = null;
    
    // Sets the type
    this._type = window.arguments[0];
    
    // Sets the data
    if (window.arguments.length > 1)
      this._data = window.arguments[1];
    
    switch (this._type)
    {
      case "account":
      {
        // Set the header
        GM_getEBI("gm-choices-header").value = GM_getBundleString("choices-account-option");
        
        item = document.createElement("menuitem");
        item.setAttribute("id", "gm-choices-item-check");
        item.setAttribute("label", GM_getBundleString("choices-option-check"));
        list.appendChild(item);
        
        item = document.createElement("menuitem");
        item.setAttribute("label", GM_getBundleString("choices-option-compose"));
        list.appendChild(item);
        
        item = document.createElement("menuitem");
        item.setAttribute("label", GM_getBundleString("choices-option-open"));
        list.appendChild(item);
        
        // Select first option
        list.parentNode.selectedItem = list.firstChild;
        
        break;
      }
      case "compose":
      {
        var accounts = GM_getManager().getAccounts({});
        
        // Set the header
        GM_getEBI("gm-choices-header").value = GM_getBundleString("choices-account-compose");
        
        for (var i = 0; i < accounts.length; i++)
        {
          if (accounts[i].type != "global")
          {
            item = document.createElement("menuitem");
            item.setAttribute("label", accounts[i].email);
            list.appendChild(item);
          }
        }
        
        // Select first account
        if (list.hasChildNodes())
          list.parentNode.selectedItem = list.firstChild;
        
        break;
      }
      default:
        this.cancel();
        break;
    }
    
    // Update fields
    this.action();
  },
  
  action: function()
  {
    var list = GM_getEBI("gm-choices-options").parentNode;
    var show = (list.selectedItem == GM_getEBI("gm-choices-item-check"));
    GM_getEBI("gm-choices-tab-location").parentNode.disabled = show;
  },
  
  accept: function()
  {
    var choice = null;
    var account = null;
    var loc = GM_getEBI("gm-choices-tab-location").parentNode.selectedIndex;
    
    switch (this._type)
    {
      case "account":
      {
        choice = GM_getEBI("gm-choices-options").parentNode.selectedIndex;
        account = GM_getManager().getAccount(this._data);
        
        // Query service
        GM_queryService(account);
        
        switch (choice)
        {
          case 0:
            account.loggedIn ? account.check() : account.login();
            break;
          case 1:
            GM_loadGmailPage("compose", account, loc, null);
            break;
          case 2:
            GM_loadGmailPage("inbox", account, loc, null);
            break;
        }
        break;
      }
      case "compose":
      {
        choice = GM_getEBI("gm-choices-options").parentNode.label;
        account = GM_getManager().getAccount(choice);
        
        GM_loadGmailPage("compose", account, loc, this._data);
        break;
      }
    }
    
    this.cancel();
  },
  
  cancel: function()
  {
    self.close();
  }
}